/* $Id: parsehtml.h,v 1.3 2001/10/06 22:09:01 aa5779 Exp $ */
#ifndef PARSEHTML_H
#define PARSEHTML_H

#include "lists.h"
#include "dstring.h"

DEFLIST(html_param,
    dstring *name;
    dstring *val;
);

typedef struct html_chunk
{
	int is_dynamic;
    int type;
    union
    {
		dstring *name;
		int ch;
    } x;
    html_param *params;
} html_chunk;

enum html_chunk_types { hct_none, hct_char, hct_tag};

html_chunk *alloc_html_chunk(void);
html_chunk *copy_html_chunk(html_chunk *hc);

#define HTML_CHUNK_TYPE(c) ((c)->type)

char *get_html_param(html_chunk *chunk, char *name);
void set_html_param(html_chunk *chunk, dstring *name, dstring *val);
void remove_html_param(html_chunk *chunk, dstring *name);
void clear_html_params(html_chunk *chunk);
void set_tag_name(html_chunk *chunk, dstring *newname);
char *get_tag_name(html_chunk *chunk);

#define HTML_NO_CHAR (-1)

int get_html_char(html_chunk *chunk);
void set_html_char(html_chunk *chunk, int ch);

void destroy_html_param(html_param *parm);

void release_html_chunk(html_chunk *chunk);
void reset_html_chunk(html_chunk *chunk);

#endif
